<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Chomsky!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>
    <section>
        <title>Decimálisból unárisba átváltó Turing gép</title>
        <para>
            Állapotátmenet gráfjával megadva írd meg ezt a gépet!
        </para>
        <para>
            Megoldás forrása: az első előadás <link xlink:href="https://arato.inf.unideb.hu/batfai.norbert/UDPROG-BHAX/Prog1_1.pdf">27 fólia</link>.               
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
        <para>
A decimálisból unárisba átvaltó turing gép úgy működik, hogy a decimális számjegyei közül az utolsó tagot eggyel csökkenti és minden egyes csökkentes után ír egy egyes számot. Ha az egyes helyiérteken 0 áll és még a tízesek helyén áll szám, akkor levesz eggyet a tízes helyiértéken álló számbol ír egy egyest majd a 0-t 9-esre írja át, és így halad tovább amíg el nem fogynak a szamok. Outputnak pedig annyi darab 1-est kapunk amennyi a beirt szam decimalis értéke volt. A program kód-ja:
<programlisting><![CDATA[
#include <iostream>

main(){

std::cout<<"adja meg a decimalisbol unarisba valtando szamot!"<<std::endl;
int decimalis=0;
std::cin>>decimalis;
int j = decimalis;
for(int i = 0;i<j;i++){
    std::cout<<"1";
}
std::cout<<std::endl;

}
]]></programlisting>
</para>
    </section>        
        
    <section>
        <title>Az a<superscript>n</superscript>b<superscript>n</superscript>c<superscript>n</superscript> nyelv nem környezetfüggetlen</title>
        <para>
            Mutass be legalább két környezetfüggő generatív grammatikát, amely ezt a nyelvet generálja!
        </para>
        <para>
            Megoldás forrása: az első előadás <link xlink:href="https://arato.inf.unideb.hu/batfai.norbert/UDPROG-BHAX/Prog1_1.pdf">30-32 fólia</link>.               
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
        <para>
Egy amerikai nyelvész Noam Chomsky nevéhez kötődik. A formális nyelvek osztályozására szolgál a Chomsky-hierarchia. A formális nyelv elemeit kifejezőerő alapjan sorolja be, tehat az erősebb osztályok képesek lesznek a gyengébb osztályok elemeinek a létrehozására. Ennek a Chomsky által létrehozott generatív nyelvtannak 4 fontos része van:-terminális szimbólumok,-nem terminális jelek,-kezdőszimbólum,-helyettesítési szabályok.
        </para>
             <programlisting>
            <![CDATA[
            S, X? Y legyenek változók
            a,b,c   legyenek konstansok
            
            S - abc, S - aXbc, Xb - bX, Xc - Ybcc, bY - Yb, aY - aaX, aY - aa
            
            S (S - axBc)
            aXbc (Xb - bX)
            abXc (Xc - Ybcc)
            abYbcc (bY - Yb)
         !. aYbbcc (aY - aa)
            aabbcc
         
         !. aYbbcc (aY - aaX)
            aaXbbcc (Xb - bX)
            aabXbcc (Xb - bX)
            aabbXcc (Xc - Ybcc)
            aabbYbccc (bY - Yb)
            aabYbbccc (bY - Yb)
            aaYbbbccc (aY - aa)
            aaabbbccc
            
]]>
        </programlisting>
        <programlisting>
            <![CDATA[
            A, B, C változók
            a, b, c konstansok
            A - aAB, A - aC, CB - bCc, cB - Bc, C - bc
            
         !. A (A - aAB)
            aAB ( A - aC)
            aaCB (CB - bCc)
            aabCc (C - bc)
            aabbcc
            
         !. A (A - aAB)
            aAB ( A - aAB)
            aaABB ( A - aAB)
            aaaABBB ( A - aC)
            aaaaCBBB (CB - bCc)
            aaaabCcBB (cB - Bc)
            aaaabCBcB (cB - Bc)
            aaaabCBBc (CB - bCc)
            aaaabbCcBc (cB - Bc)
            aaaabbCBcc (CB - bCc)
            aaaabbbCccc (C - bc)
            aaaabbbbcccc
]]>
        </programlisting>    
    </section>        
                
    <section>
        <title>Hivatkozási nyelv</title>
        <para>
            A <citation>KERNIGHANRITCHIE</citation> könyv C referencia-kézikönyv/Utasítások melléklete alapján definiáld 
            BNF-ben a C utasítás fogalmát!
            Majd mutass be olyan kódcsipeteket, amelyek adott szabvánnyal nem fordulnak (például C89), mással (például C99) igen.
        </para>
        <para>
            Megoldás forrása: az első előadás <link xlink:href="https://arato.inf.unideb.hu/batfai.norbert/UDPROG-BHAX/Prog1_1.pdf">63-65 fólia</link>.               
        </para>
        <para>
<link xlink:href="szabvany.c">
<filename>
bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/szabvany.c
</filename>
</link>
</para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>   
<para>
A kódok fordításához többféle szabvány használata közül választhatunk. A nyelveket állandóan fejlesztik ezért vannak olyan esetek, amikor bekerül egy új dolog a nyelvbe. Ilyenkor a fordítási szabványokat is meg kell változtatni. Tehát vannak olyan esetek amikor egy olyan funkcióját használjuk a nyelvnek, amit a régi szabványok nem ismernek, így fordításkor meg kell adnunk, hogyha egy bizonyos szabvány segítségével akarjuk a kódunkat lefordítani.
</para>

<para>
<mediaobject>
<imageobject>
<imagedata fileref="szabvany.png" scale="50"/>
</imageobject>
</mediaobject>
</para>
<programlisting language="c"><![CDATA[%{
#include <stdio.h>

int main(){
    //a comment
    return 0;
}
]]></programlisting>
    </section>                     

    <section>
        <title>Saját lexikális elemző</title>
        <para>
            Írj olyan programot, ami számolja a bemenetén megjelenő valós számokat! 
            Nem elfogadható olyan megoldás, amely maga olvassa betűnként a bemenetet, 
            a feladat lényege, hogy lexert használjunk, azaz óriások vállán álljunk és ne kispályázzunk!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/9KnMqrkj_kU">https://youtu.be/9KnMqrkj_kU</link> (15:01-től).
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Chomsky/realnumber.l">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/realnumber.l</filename>
            </link> 
        </para>
        <programlisting language="c"><![CDATA[%{
#include <stdio.h>
int realnumbers = 0;
%}
digit	[0-9]
%%
{digit}*(\.{digit}+)?	{++realnumbers; 
    printf("[realnum=%s %f]", yytext, atof(yytext));}
%%
int
main ()
{
 yylex ();
 printf("The number of real numbers is %d\n", realnumbers);
 return 0;
}
]]></programlisting>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
        <para>
        A feladat megoldásához a .l kódot lex használatával kell fordítanunk. Ez generánlni fog egy .c kódot amit "gcc lex.yy.c -lfl"-el tudunk fordítani és "./a.out"-tal futtatni. Ahhoz viszont hogy a lex-et használni tudjuk telepítenünk kell a flex-et "sudo apt install flex" paranccsal ezt meg is tudjuk tenni, feltéve ha van engedélyünk használni a sudo parancsot.
        </para>
        <para>
        A futó program ctrl-d használatával tudjuk leállítani, ezután a console-ra kiírja a beírt valós számok darabszámát. A program egy hosszú szöveget is tud elemezni, és ki tudja írni belőle a valós számok darabszámát.
        </para>
        <para>
<mediaobject>
<imageobject>
<imagedata fileref="real.png" scale="50"/>
</imageobject>
</mediaobject>
</para>
  <para>
<mediaobject>
<imageobject>
<imagedata fileref="real2.png" scale="35"/>
</imageobject>
</mediaobject>
</para>
    </section>                     

    <section>
        <title>Leetspeak</title>
        <para>
            Lexelj össze egy l33t ciphert!
        </para>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/06C_PqDpD_k">https://youtu.be/06C_PqDpD_k</link>
        </para>
        <para>
            Megoldás forrása: <link xlink:href="Chomsky/l337d1c7.l">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/l337d1c7.l</filename>
            </link>  
        </para>
        <programlisting language="c"><![CDATA[%{
  #include <stdio.h>
  #include <stdlib.h>
  #include <time.h>
  #include <ctype.h>

  #define L337SIZE (sizeof l337d1c7 / sizeof (struct cipher))
    
  struct cipher {
    char c;
    char *leet[4];
  } l337d1c7 [] = {

  {'a', {"4", "4", "@", "/-\\"}},
  {'b', {"b", "8", "|3", "|}"}},
  {'c', {"c", "(", "<", "{"}},
  {'d', {"d", "|)", "|]", "|}"}},
  {'e', {"3", "3", "3", "3"}},
  {'f', {"f", "|=", "ph", "|#"}},
  {'g', {"g", "6", "[", "[+"}},
  {'h', {"h", "4", "|-|", "[-]"}},
  {'i', {"1", "1", "|", "!"}},
  {'j', {"j", "7", "_|", "_/"}},
  {'k', {"k", "|<", "1<", "|{"}},
  {'l', {"l", "1", "|", "|_"}},
  {'m', {"m", "44", "(V)", "|\\/|"}},
  {'n', {"n", "|\\|", "/\\/", "/V"}},
  {'o', {"0", "0", "()", "[]"}},
  {'p', {"p", "/o", "|D", "|o"}},
  {'q', {"q", "9", "O_", "(,)"}},
  {'r', {"r", "12", "12", "|2"}},
  {'s', {"s", "5", "$", "$"}},
  {'t', {"t", "7", "7", "'|'"}},
  {'u', {"u", "|_|", "(_)", "[_]"}},
  {'v', {"v", "\\/", "\\/", "\\/"}},
  {'w', {"w", "VV", "\\/\\/", "(/\\)"}},
  {'x', {"x", "%", ")(", ")("}},
  {'y', {"y", "", "", ""}},
  {'z', {"z", "2", "7_", ">_"}},
  
  {'0', {"D", "0", "D", "0"}},
  {'1', {"I", "I", "L", "L"}},
  {'2', {"Z", "Z", "Z", "e"}},
  {'3', {"E", "E", "E", "E"}},
  {'4', {"h", "h", "A", "A"}},
  {'5', {"S", "S", "S", "S"}},
  {'6', {"b", "b", "G", "G"}},
  {'7', {"T", "T", "j", "j"}},
  {'8', {"X", "X", "X", "X"}},
  {'9', {"g", "g", "j", "j"}}
  
// https://simple.wikipedia.org/wiki/Leet
  };
  
%}
%%
.	{
	  
	  int found = 0;
	  for(int i=0; i<L337SIZE; ++i)
	  {
	  
	    if(l337d1c7[i].c == tolower(*yytext))
	    {
	    
	      int r = 1+(int) (100.0*rand()/(RAND_MAX+1.0));
	    
          if(r<91)
	        printf("%s", l337d1c7[i].leet[0]);
          else if(r<95)
	        printf("%s", l337d1c7[i].leet[1]);
	      else if(r<98)
	        printf("%s", l337d1c7[i].leet[2]);
	      else 
	        printf("%s", l337d1c7[i].leet[3]);

	      found = 1;
	      break;
	    }
	    
	  }
	  
	  if(!found)
	     printf("%c", *yytext);	  
	  
	}
%%
int 
main()
{
  srand(time(NULL)+getpid());
  yylex();
  return 0;
}
]]></programlisting>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
        <para>
        A programban megadunk egy szótárat, ezt bármire átírhatjuk, de vannak előre megírt szótárak is. Ezekeben betűket helyettesítő karaktereket találunk. A program betűnként elemzi a beírt szövegünket, és kicseréli a szótárban megadott karakterekkel a beírt szöveg karaktereit. Ahhoz hogy ne mindig ugyan azt a karaktert ugyanarra a karakterre cserélje készíthetünk hozzá egy randomizálót, ami segítségével több karaktert használhatunk a szótárból.
        </para>
        <para>
<mediaobject>
<imageobject>
<imagedata fileref="1337.png" scale="50"/>
</imageobject>
</mediaobject>
</para>
    </section>                     


    <section>
        <title>A források olvasása</title>
        <para>
            Hogyan olvasod, hogyan értelmezed természetes nyelven az alábbi kódcsipeteket? Például
            <programlisting><![CDATA[if(signal(SIGINT, jelkezelo)==SIG_IGN)
    signal(SIGINT, SIG_IGN);]]></programlisting>
            Ha a SIGINT jel kezelése figyelmen kívül volt hagyva, akkor ezen túl is legyen
            figyelmen kívül hagyva, ha nem volt figyelmen kívül hagyva, akkor a jelkezelo függvény
            kezelje. (Miután a <command>man 7 signal</command> lapon megismertem a SIGINT jelet, a
            <command>man 2 signal</command> lapon pedig a használt rendszerhívást.)
        </para>

        <caution>
            <title>Bugok</title>
            <para>
                Vigyázz, sok csipet kerülendő, mert bugokat visz a kódba! Melyek ezek és miért? 
                Ha nem megy ránézésre, elkapja valamelyiket esetleg a splint vagy a frama?
            </para>
        </caution>
            
        <orderedlist numeration="lowerroman">
<listitem>
<programlisting>
<![CDATA[
if(signal(SIGINT, SIG_IGN)!=SIG_IGN) signal(SIGINT, jelkezelo);
]]>
</programlisting>
<para>
A SIGINT jelet kezelje a jelkezelő, ha a SIGINT nincs ignorálva.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ for(i=0; i<5; ++i) ]]>
</programlisting>
<para>
A for ciklus 5-ször lesz végrehajtva. A nulladiktól a negyedik iterációig. Azaz 5 iteráción keresztül. Ha mindegyik végen kiíratnánk az i-t akkor a:0 1 2 3 4 számokat kapnánk.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ for(i=0; i<5; i++) ]]>
</programlisting>
<para>
A for ciklus 5-ször lesz végrehajtva. A nulladiktól a negyedik iterációig. Azaz 5 iteráción keresztül. Ha mindegyik végen kiíratnank az i-t akkor a:0 1 2 3 4 számokat kapnánk. Az előzőhöz képest a különbség szinte csak stílusbeli.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ for(i=0; i<5; tomb[i] = i++) ]]>
</programlisting>
<para>
A for ciklus minden iteráció végén lecseréli a tömb értékét az i++ viszatérési értékével.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ for(i=0; i<n && (*d++ = *s++); ++i) ]]>
</programlisting>
<para>
Ez a for ciklus nem működik, mert a (*d++ = *s++) értéke integer, és nem boolean. Olvashatjuk a splint használatával, az "undefined behaviour" alatt.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ printf("%d %d", f(a, ++a), f(++a, a)); ]]>
</programlisting>
<para>
Standard outputra kiírjuk az f függvény értékét a következő programbol

             <link xlink:href="test.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/test.c</filename>
            </link>  
<programlisting language="c">
<![CDATA[
#include <stdio.h> 
int f(int a, int b){ 
printf("valami:%d %d\n", a,b); 
return a; 
} int main(){ 
int a = 0; 
printf("%d %d\n", f(a,++a), f(++a,a)); 
return 0; 
}
]]>
</programlisting>
A következő értékeket kapjuk::1 1, 2 2, 2 1
</para>
<para>
<mediaobject>
<imageobject>
<imagedata fileref="hatodik.png" scale="50"/>
</imageobject>
</mediaobject>
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ printf("%d %d", f(a), a); ]]>
</programlisting>
<para>
Standard outputra kiíratjuk az f függvény visszatérített értékét. Az f függvenynek argumentumként adjuk át az a értékét, és kiíratjuk az a jelenlegi értékét.
</para>
</listitem>
<listitem>
<programlisting>
<![CDATA[ printf("%d %d", f(&a), a); ]]>
</programlisting>
<para>
Standard outputra kiíratjuk az f visszatérített értékét. Az f paramétere egy memória cím. Kiíratjuk az a jelenlegi értékét.
</para>
</listitem>
</orderedlist>
        <para>
            Megoldás videó: BHAX 357. adás.
        </para>

        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
<para>
A kód  csipeteket splint használatával leellenőrízhetjük nem várt output esetén. Általában ennek a használatával megtudjuk állapítani, hogy mi lehet a probléma a kóddal.
</para>
    </section>                     

    <section>
        <title>Logikus</title>
        <para>
<mediaobject>
            <imageobject>
                <imagedata fileref="arnyelv.png" scale="50"/>
            </imageobject>
        </mediaobject>
	</para>
        <para>
            Hogyan olvasod természetes nyelven az alábbi Ar nyelvű formulákat?
        </para>
        <programlisting language="tex"><![CDATA[$(\forall x \exists y ((x<y)\wedge(y \text{ prím})))$ 

$(\forall x \exists y ((x<y)\wedge(y \text{ prím})\wedge(SSy \text{ prím})))$ 

$(\exists y \forall x (x \text{ prím}) \supset (x<y)) $ 

$(\exists y \forall x (y<x) \supset \neg (x \text{ prím}))$
]]></programlisting>        
        <para>
            Megoldás forrása: <link xlink:href="https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/MatLog_LaTeX">https://gitlab.com/nbatfai/bhax/blob/master/attention_raising/MatLog_LaTeX</link>
        </para>

        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/ZexiPy3ZxsA">https://youtu.be/ZexiPy3ZxsA</link>, <link xlink:href="https://youtu.be/AJSXOQFF_wk">https://youtu.be/AJSXOQFF_wk</link>
        </para>


        <para>
Tanulságok, tapasztalatok, magyarázat... Az Ar nyelv egy logikai nyelv, amiben használhatunk konjunkciót, diszjunkciót, implikaciót, és negáciot, illetve hasznalhatunk különböző matematikai műveleteket mint például az összeadás és szorzás, ezen felül használhatóak meg a kisebb,a nagyobb és egyenlő jelek. A fenti szabályok felhasználásával könnyen értelmezhetőek az összetett elsőrendű formulák. 
        </para>
	<para>
<programlisting language="tex"><![CDATA[$(\forall x \exists y ((x<y)\wedge(y \text{ prím})))$
]]></programlisting>  
A primszámok száma végtelen.   
	</para>
<para>
<programlisting language="tex"><![CDATA[$(\forall x \exists y ((x<y)\wedge(y \text{ prím})\wedge(SSy \text{ prím})))$
]]></programlisting> 
Az ikerprimek száma végtelen.    
	</para>
<para>
<programlisting language="tex"><![CDATA[$(\exists y \forall x (x \text{ prím}) \supset (x<y))$
]]></programlisting> 
A primszámok száma véges.   
	</para>
<para>
<programlisting language="tex"><![CDATA[$(\exists y \forall x (y<x) \supset \neg (x \text{ prím}))$
]]></programlisting> 
A primszámok száma végtelen.   
	</para>
    </section>                                                                                                                                                                            
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
    <section>
        <title>Deklaráció</title>
            
        <para>
            Vezesd be egy programba (forduljon le) a következőket: 
        </para>

        <itemizedlist>
            <listitem>
                <para>egész</para>                        
            </listitem>
            <listitem>
                <para>egészre mutató mutató</para>                        
            </listitem>
            <listitem>
                <para>egész referenciája</para>                        
            </listitem>
            <listitem>
                <para>egészek tömbje</para>                        
            </listitem>
            <listitem>
                <para>egészek tömbjének referenciája (nem az első elemé)</para>                        
            </listitem>
            <listitem>
                <para>egészre mutató mutatók tömbje</para>                        
            </listitem>
            <listitem>
                <para>egészre mutató mutatót visszaadó függvény</para>                        
            </listitem>
            <listitem>
                <para>egészre mutató mutatót visszaadó függvényre mutató mutató</para>                        
            </listitem>
            <listitem>
                <para>egészet visszaadó és két egészet kapó függvényre mutató mutatót visszaadó, egészet kapó függvény</para>                        
            </listitem>            
            <listitem>
                <para>függvénymutató egy egészet visszaadó és két egészet kapó függvényre mutató mutatót visszaadó, egészet kapó függvényre</para>                        
            </listitem>            
        </itemizedlist>            
<para>
 <link xlink:href="deklaracio.cpp">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/deklaracio.cpp</filename>
            </link> 
	<programlisting language ="c++"><![CDATA[

int main()
{

	//egész
	int a;

	//egészre mutató mutató
	int *b = &a;

	//egész referenciája
	int &r = a;

	//egészek tömbje
	int c[5];

	//egészek tömbjének referenciája
	int (&tr) [5]  = c;

	//egészre mutató mutatók tömbje
	int *d[5];

	//egészre mutató mutatót visszaadó függvény
	int *h ();

	//egészre mutató mutatót visszaadó függvényre mutató mutató
	int *(*l) (); 

	//egészet visszaadó és két egészet kapó függvényre mutató mutatót visszaadó, egészet kapó függvény
	int (*v (int c)) (int a, int b);

    //függvénymutató egy egészet visszaadó és két egészet kapó függvényre mutató mutatót visszaadó, egészet kapó függvényre
    int (*(*z) (int)) (int, int);


	return 0;
}
]]></programlisting> 
	</para>
        <para>
            Mit vezetnek be a programba a következő nevek?
        </para>

             <itemizedlist>
            <listitem>
                <programlisting><![CDATA[int a;]]></programlisting> 
<para>
a-val jelölt integer típusu változó.
	</para>               
            </listitem>
            <listitem>
                <programlisting><![CDATA[int *b = &a;]]></programlisting>
                  <para>
b-vel jelölt integerre mutató mutató .
	</para> 
            </listitem>
            <listitem>
                <programlisting><![CDATA[int &r = a;]]></programlisting> 
              <para>
r-rel jelölt integer referencia.
	</para>
            </listitem>
            <listitem>
                <programlisting><![CDATA[int c[5];]]></programlisting> 
    <para>
c-vel jelolt 5 elemű tömb.
	</para>   
            </listitem>
            <listitem>
                <programlisting><![CDATA[int (&tr)[5] = c;]]></programlisting>
            <para>
5 elemű integerekből álló tömb referenciája, ami a c tömbre mutat.
	</para>    
            </listitem>
            <listitem>
                <programlisting><![CDATA[int *d[5];]]></programlisting> 
           <para>
5 elemű, integerekre mutató mutatók tömbje.
	</para>     
            </listitem>
            <listitem>
                <programlisting><![CDATA[int *h ();]]></programlisting> 
           <para>
Integerre mutató mutatóval visszaterő függvény.
	</para>   
            </listitem>
            <listitem>
                <programlisting><![CDATA[int *(*l) ();]]></programlisting> 
           <para>
Integerre mutató mutatóval visszatérő függvenyre mutató mutató.
	</para>  
            </listitem>
            <listitem>
                <programlisting><![CDATA[int (*v (int c)) (int a, int b)]]></programlisting>  
          <para>
Integerrel visszatérő 2 integert kapó függvenyre mutató mutatóval visszatérő, integert kapó függvény.
	</para>    
            </listitem>            
            <listitem>
                <programlisting><![CDATA[int (*(*z) (int)) (int, int);]]></programlisting>      
      <para>
Integerrel visszatérő, 2 integert kapó függvényre mutató mutatót visszaadó, integert váró függvényre mutató.
	</para>               
            </listitem>            
            <listitem>
                <programlisting><![CDATA[int (*(*z) (int)) (int, int);]]></programlisting>      
      <para>
Jelölt integerrel visszatérő, 2 jelölt integert paraméterként váró függvényre mutató, jelölt integert váró függvényre mutató mutató.
	</para>           
  
            </listitem>            
        </itemizedlist>        


        <para>
            Megoldás videó: BHAX 357. adás.
        </para>
        <para>
            Az utolsó két deklarációs példa demonstrálására két olyan kódot
            írtunk, amelyek összahasonlítása azt mutatja meg, hogy miért 
            érdemes a <command>typedef</command> használata: <link xlink:href="Chomsky/fptr.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/fptr.c</filename>
            </link>,
            <link xlink:href="Chomsky/fptr2.c">
                <filename>bhax/thematic_tutorials/bhax_textbook_IgyNeveldaProgramozod/Chomsky/fptr2.c</filename>.
            </link>  
            
        </para>
        <programlisting><![CDATA[#include <stdio.h>

int
sum (int a, int b)
{
    return a + b;
}

int
mul (int a, int b)
{
    return a * b;
}

int (*sumormul (int c)) (int a, int b)
{
    if (c)
        return mul;
    else
        return sum;

}

int
main ()
{

    int (*f) (int, int);

    f = sum;

    printf ("%d\n", f (2, 3));

    int (*(*g) (int)) (int, int);

    g = sumormul;

    f = *g (42);

    printf ("%d\n", f (2, 3));

    return 0;
}]]></programlisting>            
        <programlisting><![CDATA[#include <stdio.h>

typedef int (*F) (int, int);
typedef int (*(*G) (int)) (int, int);

int
sum (int a, int b)
{
    return a + b;
}

int
mul (int a, int b)
{
    return a * b;
}

F sumormul (int c)
{
    if (c)
        return mul;
    else
        return sum;
}

int
main ()
{

    F f = sum;

    printf ("%d\n", f (2, 3));

    G g = sumormul;

    f = *g (42);

    printf ("%d\n", f (2, 3));

    return 0;
}
]]></programlisting>            
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>
    </section>                     
    <section>
        <title>Vörös Pipacs Pokol/csiga diszkrét mozgási parancsokkal</title>
        <para>
            Megoldás videó: <link xlink:href="https://youtu.be/Fc33ByQ6mh8">https://youtu.be/Fc33ByQ6mh8</link>      
        </para>
        <para> 
<link xlink:href="https://www.youtube.com/watch?v=Cc0yxRrJhRA"></link>              
        </para>
        <para>
            Megoldás forrása: <link xlink:href="https://github.com/nbatfai/RedFlowerHell">https://github.com/nbatfai/RedFlowerHell</link>               
        </para>
        <para>
            Tanulságok, tapasztalatok, magyarázat... ezt kell az olvasónak kidolgoznia, mint labor- vagy otthoni mérési feladatot!
            Ha mi már megtettük, akkor használd azt, dolgozd fel, javítsd, adj hozzá értéket!
        </para>   
        <para>
        A feladat megoldásához el kell vezetnünk steve-et a falig majd megkell mondanunk neki hogy ugordjon fel, ezután előre megy egyet és megfordul. Újra elmegy a falig felugrik elmegy a falig megdordul. Minden iteráció után 4-gyel többet kell előre mennie.
        </para>         
    </section>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
</chapter>                
